/*Onoma: Gewrgios Vougioukas
*A.M: 2011030011
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <pthread.h>
#include <sys/stat.h>
#include <time.h>
#include "linkedlist.h"
#include "hashtable.h"
#include "scall.h"
#include "htm.h"
#include "gutils.h"
#include "linkedlist.h"
#include "cache.h"



/*Ayto to arxeio apotelei ton kwdika ths cache
*exei dokimastei aneksarthta apo ola ta ala me mia mikrh main
*pou eixa gia tis dokimes twn synarthsewn (kathe synarthsh einai dokimasmenh
*aneksarthta apo tis ales).To lru exei dokimastei gia thn orth tou leitourgeia me
*printf kai megethos cache 4. H leitourgia ths gia pola nhmata exei dokimastei
*epishs me ena printf p deixnei tis egrafes ana pasa stigmh
*/


/*h higher level synarthsh, ayth kalei to thread pou diaxeirizetai
*th syndesh gia na parei th selida pou tha steilei ston client
*(browser)
*/
char *get_page(char *path,Cache *cache)
{
	char *tmp="",*tmp2="";
	cache_entry *entry2=NULL;
	
	/*me to apo katw printf fenetai, an otan tou kanw blast aithmata
	*me to ab an px gia -c 10 kanei mono 1 entry kai oxi 10
	*/
	//fprintf(stderr,"CACHE ENTRIES: %d\n",cache->entry_count);


	/*apo dw kai katw grafw/epeksergazome/diavazw koinoxrhstes
	*(apo nhmata) domes, opote lokarw me thread mutex
	*/

	pthread_mutex_lock(&cache->mutex);

	if (cache->entry_count==0) //h cache einai adia
	{	
		tmp=create_and_insert(path,cache);//dhmiourgw egrafh k th vzw sth cache
		List_begin(&cache->lru_list)->data=path;
		pthread_mutex_unlock(&cache->mutex);
		return tmp;
	}
	else
	{
		entry2=NULL;
		entry2=get(cache,path);
		
		if (entry2==NULL)//den yparxei tetoia egrafh
		{
			
			if (cache->entry_count<M) //den einai gemath h cache
			{
				tmp2=create_and_insert(path,cache);//...opote dhmiourgw selida kai thn vazw sth cache
				pthread_mutex_unlock(&cache->mutex);
				return tmp2;//kai gyrizw html
			}
			else//einai gemath
			{
				tmp2=NULL;
				delete_LRU(cache);//..opote diagrafw to lru entry
				tmp2=create_and_insert(path,cache);//kai vazw to entry p zitithike
				pthread_mutex_unlock(&cache->mutex);
				return tmp2;
			}	
		}
		else
		{

				/*h selida yparxei*/
			entry2=get(cache,path);
			if (get_version(entry2)<get_curr_version(path)) //..ala exei paliosei
			{
					tmp=NULL;
					HashTable_remove(&cache->table,path);//...opote diagrafw to palio...
					tmp=create_and_insert(path,cache);//...kai vazw to neo
					pthread_mutex_unlock(&cache->mutex);
					return tmp;
			}
			else	//h selida yparxei, xoris na exei 'paliosei'
			{
				
				rearrange_list(cache,path);//thn kanw kefalh ths lru_list
				pthread_mutex_unlock(&cache->mutex);
				return (char*)entry2->htmltext;	//...kai epistrefw html
			}
		}
		
	}
	
	
}

/*h equal pou xreiazetai o hash table gia tin isothta (exw string ara kanw mia aplh strcmp*/
int eq(const void *str1,const void *str2)
{
	return strcmp((char*)str1,(char*)str2)==0;
}

/*to hash function (strhash gia string)*/
size_t hash_func(const void *str)
{
	return strhash((char *)str);
}

/*init gia thn cache (gyrizei cache)*/
Cache cache_init()
{
	Cache cache;
	HashTable_init(&cache.table,M,hash_func,eq);
	List_init(&cache.lru_list);
	cache.entry_count=0;
	pthread_mutex_init(&cache.mutex, NULL);
	return cache;
}

/*vazei mia cache_entry struct sthn cache*/
void insert(Cache *cache,cache_entry *entr)
{
	HashTable tmp=cache->table;
	HashTable_insert(&tmp,(char*)entr->path,(cache_entry*)entr);//kanw insert
	cache->entry_count++;
}


/*mou gyrizei egrafh an thn vrei, aliws NULL*/
cache_entry *get(Cache *cache,char *key)
{
	HashTable tmp=cache->table;
	return (cache_entry*)HashTable_get(&tmp,(char*)key,NULL); //..aliws null
}



time_t get_version(cache_entry *entry)
{
	return entry->version;
}

/*ftiaxnei struct (gyrizei deikth) entry gia dedomeno path kai selida*/
cache_entry *create_entry(char *html,char *path)
{
	cache_entry *entry;

	entry=(cache_entry*)malloc(sizeof(cache_entry));
	entry_init(entry,html,path);
	entry->htmltext=html;
	entry->path=path;
	entry->htmllen=sizeof(html);
	entry->version=get_curr_version(path);
	return entry;
}


char *create_and_insert(char *path,Cache *cache)
{
	/*dedomenou path kalei thn create_html,vazei
	*sthn oura ths lru to path, dhmiourgei neo cache_entry
	*kai to vazei sthn cache (gyrizei thn html selida)
	*/
	cache_entry *entry=NULL;
	char *tmp="";
	tmp=create_html(path,"",LIST_MODE);//kalw thn routina p ftiaxnei thn telikh html
	List_push_back(&cache->lru_list,path);//vazw sth lista to path
	entry=create_entry(tmp,path);//ftiaxnw to entry p paei sthn cache
	insert(cache,entry);//kai to petaw sth cache
	return tmp;
}


void delete_LRU(Cache *cache)
{
	/*apla sthn oura ths lru, to telefteo stoixeio
	*apotelei ayto pou xrisimopoihthike teleftea fora
	*mias k apothikeyw to path, kanw pop to telefteo ths
	*stoixeio kai to xrhsimopoiw gia na vgalw thn antistoixh
	*entry apo to hash table
	*/
	char *path="";
	path=List_pop_back(&cache->lru_list);

	/*h lista exei ena thema, to opoio dn katafera na vrw ti fteei
	*kai to prokalei, thn proth fora p apothikeyeis kati se aythn
	*to grafei 2 fores, alla den yparxei sth cache 'h anafora' tou
	* 2ou stoixeiou opote enw doulevei otan paei na vgalei to stoixeio
	*ayto (yparxei san anafora path sthn lru, alla dn yparxei entry sthn cache gia ayto,
	*mias kai exei aferethei) opote petaei false h remove tou hash table,ayto diorthonete
	otan gemisei i cache kai paei na valei kati kainourio gia 2h fora apo kei k pera den exei thema
	*/

	if (!HashTable_remove(&cache->table,path))
	{
		cache->entry_count--;
		return;
	}
	cache->entry_count--;
}


void rearrange_list(Cache *cache,char *path)
{
	/*kathe fora pou xrhsimopoieite mia egrafh ths
	*cache, ayth h egrafh (to path pou ths antistoixei)
	*alazei thesh kai ginetai kefalh ths lru_list,ayto ginetai me ayth
	*th synarthsh.Arxika psaxnw me thn find_node ton komvo pou exei data ayto to
	*path, meta ton diagrafw (an exw k alous komvous mesa) kai ton kanw tin nea kefalh
	*ths lru_list
	*/
	ListNode p,be;
	if (cache->entry_count>1)
	{
		p=find_node(path,&cache->lru_list);
		if (p==List_begin(&cache->lru_list))
		{

		}
		else
		{
			List_remove(p);
			be=List_begin(&cache->lru_list);
			List_insert_after(be,be->data);
			List_begin(&cache->lru_list)->data=path;
		}	
	}
}

/*kanei free ta melh ths entry*/
void free_entry(cache_entry *entry)
{
	free(entry->htmltext);
	free(entry->path);
	free(entry);
}

/*kanei init mia entry*/
void entry_init(cache_entry *entry,char *text,char *path)
{
	entry->htmltext=(char*)malloc(sizeof(text));
	entry->path=(char*)malloc(sizeof(path));
	//entry->version=(time_t*)malloc(sizeof(time_t));
	
}
