/*Onoma: Gewrgios Vougioukas
*A.M: 2011030011
*/

#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include "linkedlist.h"
#include "threadpool.h"
#include "gutils.h"

/*ayto to arxeio apotelei ton kodika tou threadpool
*h ylopoihsh tou vasisthke sthn idea tou threadpool 
*opws parousiazetai sto sxetiko page ths wikipedia.
*H idea einai oti exoume 10 nhmata-ergates ta opoia
*perimenoun na tous erthei kapoio task gia na to doulepsoun.
*Exoume mia oura (ylopoihmenh me thn linkedlist pou dinetai) sthn opoia kratame pointers
*se struct task, opou exei ta parakatw melh:
*	--void *(*func)(void*): h synartish pou tha ektelesh o ergaths
*	--void *arg: to orisma ths parapanw synarthshs
*	--pthread_t t_id: to to id tou thread pou doulevei thn synarthsh, einai lathos opws to xo kanei, alla ok den xreiasthke kapou gia na to psaksw
*Afou kanoume init (mutex,cv,thn lista klp) dinoume sta nhmata-ergates na ektelesoun thn thread_begin.
*Ayth h synarthsh ousiastika kanei ton ergath na perimenei mexri na tou rthei kapoio task. Exoume ena while(1) etsi wste
*otan teliosei to task pou dothike ston ergath na gyrisei kai na ksanakoimithei/perimenei mexri na exei task gia ektelesh.
*Th leitourgia tou 'o ergaths perimenei' thn petyxenw xrhsimopoiwntas ena cv, etsi otan erthei ena task (dld otan kapoios kalesei
*thn threadpool spawn) ayto benei sthn oura kai otan bei sthn oura ginetai ena signal sto cv, ksypnaei kapoios p koimate panw se ayto to
*cv kanei dequeue, tsibaei to task tou kai to ektelei. Thn wait tou cv thn exw mesa sto while, pou elegxetai apo to an h oura
*einai adia, ayto to kanw gia na mn yparksoun akyra ksypnimata apo ta nhmata.Etsi px thn proth fora ekteleshs ths init:
* 1)tha bei to nhma k tha kanei lock to mutex
* 2)tha dei oti h oura einai adia kai tha meinei sto w8 kseklidonontas to mutex
* 3)ta ypoloipa MAX_WORKERS-1 nhmata tha kanoun to idio.
* 4)otan erthei ena task (kapoios kalesei thn threadpool_spawn) h lista tha exei ena stoixeio opote den tha einai adia pleon
* 5)ginetai signal k ksypnaei enas worker ksanapaei sth synthikh gia thn oura (while) vlepei oti einai gemath kai fevgei
* 6)tsibaei to task kai to ektelei
*ena provlhma p exei o kwdikas einai oti den epistrefei swsto thread id (epistrefei 0),den ekatsa na to psaksw gt den to
*xreiasthka kapou
*/


/*to threadpool exei dokimastei gia thn orthh tou leitourgia aneksarthta
*apo ton ypoloipo kwdika, xrhsimopoiwntas mia mikrh main, pou etrexe mia synarthsh
*(thn do_loop tou pdf gia ta threads sto courses) arxika me nhmata apo to pthread_create
*kai sth synexeia me to diko mou threadpool_spawn. Ta apotelesmata htan idia.
*/


void ThreadPool_init(ThreadPool *this)
{
	int i=0;
	this->task_count=0;
	List_init(&this->list);
	if (pthread_mutex_init(&this->mutex,NULL)!=0)//init tou mutex
	{
		error("pthread_mutex_init");
	}
	

	if (pthread_cond_init(&this->cv,NULL))//...tou cv
	{
		error("pthread_cond_init");
	}


	for (i=0;i<MAX_WORKERS;i++)//ftiaxnw ta nhmata-ergates
	{
		pthread_create(&this->workers[i],NULL,thread_begin, (void*)this);
	}
}

pthread_t ThreadPool_spawn(ThreadPool *this,void *(*func)(void *),void *arg)
{

	pthread_t t_id;
	pthread_mutex_lock(&this->mutex); //lokaroume (koinoxrhsth domh)

	task *task0;
	task0=(task*)malloc(sizeof(task));
	task0->func=func;
	task0->arg=arg;
	List_push_back(&this->list,task0);//vazw to task sthn oura
	this->task_count++;//an kai den to xrhsimopoiw kapou, to afhnw isws xreiastei kapou alou
	pthread_cond_signal(&this->cv);//kanw signal na ksypnhsei kanas ergaths
	t_id=task0->t_id;//ayto pistevw oti den doulevei :-P
	pthread_mutex_unlock(&this->mutex);
	return t_id;

}

void *thread_begin(void *ptr)
{
	pthread_detach(pthread_self());//opws leei i ekfonhsh
	ThreadPool *this;
	task *task0;
	
	this=(ThreadPool*)ptr;

	while(1)
	{
		pthread_mutex_lock(&this->mutex);//lokarw (oura koinoxrhsth domh)
		while(List_empty(&this->list)==1) //gia na mhn exw ypopta ksypnimata
		{
			pthread_cond_wait(&this->cv,&this->mutex);
		}
		
		task0=(task*)List_pop_front(&this->list);//pernw to task mou
		task0->t_id=pthread_self();
		this->task_count--;//to eksipirethsa ara mionw ton counter
		pthread_mutex_unlock(&this->mutex);
		(*(task0->func))(task0->arg); //...kai to trexw
	}
	pthread_exit(NULL);
	return NULL; //mono k mono gia na mn vgazei warning
}

